# Extended Listbox


[![Travis](https://img.shields.io/travis/code-chris/extended-listbox.svg?branch=master)](https://travis-ci.org/code-chris/extended-listbox)
[![NPM](https://img.shields.io/npm/v/extended-listbox.svg)](https://www.npmjs.com/package/extended-listbox)
[![Bower](https://img.shields.io/bower/v/extended-listbox.svg)](https://github.com/code-chris/extended-listbox)
[![David](https://img.shields.io/david/dev/code-chris/extended-listbox.svg)](https://david-dm.org/code-chris/extended-listbox)
[![Coverage Status](https://coveralls.io/repos/code-chris/extended-listbox/badge.svg?branch=master&service=github)](https://coveralls.io/github/code-chris/extended-listbox?branch=master)
[![bitHound Overall Score](https://www.bithound.io/github/code-chris/extended-listbox/badges/score.svg)](https://www.bithound.io/github/code-chris/extended-listbox)


**Extended Listbox** is a simple to use jQuery plugin as powerful
alternative to the HTML `<select>` tag. The main problem of
`<select>` tag is that last one isn’t flexible for customization with
*CSS*. Extended Listbox solves this problem. This component creates a list
structure based on `<div>` tags. The configuration is completely in
JavaScript. It opens up great possibilities for customization.

In addition, this component provides other useful features like a search
bar or group items.

## Installation

Install with bower:
```
bower install extended-listbox
```
Install with NPM:
```
npm install extended-listbox
```
Install TypeScript Definitions:
```
tsd install extended-listbox
```


## Usage

Link the component and a stylesheet from your page.

```html
<!-- make sure that jQuery is already included -->
<script src="/path/to/jquery.js"></script>

<!-- include listbox plugin and default stylesheet -->
<link href="/path/to/extended-listbox.css" rel="stylesheet">
<script src="/path/to/extended-listbox.js"></script>
```


[Documentation](http://code-chris.github.io/extended-listbox/documentation/latest/index.html)
--------------
[License](https://github.com/code-chris/extended-listbox/blob/master/LICENSE)
--------
[Changelog](https://github.com/code-chris/extended-listbox/blob/master/doc/CHANGELOG.md)
----------
[Roadmap](https://github.com/code-chris/extended-listbox/blob/master/doc/ROADMAP.md)
--------
